using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.IO;

namespace SimpleWebRequest
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine(
                PostDataToUrl("test", "http://www.microsoft.com")
                );
        }

        /// <summary>
        /// Post dataurl
        /// </summary>
        /// <param name="data">Ҫpost</param>
        /// <param name="url">Ŀurl</param>
        /// <returns>Ӧ</returns>
        static string PostDataToUrl(string data, string url)
        {
            Encoding encoding = Encoding.GetEncoding(sRequestEncoding);
            byte[] bytesToPost = encoding.GetBytes(data);
            return PostDataToUrl(bytesToPost, url);
        }

        /// <summary>
        /// Post dataurl
        /// </summary>
        /// <param name="data">Ҫpost</param>
        /// <param name="url">Ŀurl</param>
        /// <returns>Ӧ</returns>
        static string PostDataToUrl(byte[] data, string url)
        {
            #region httpWebRequest
            WebRequest webRequest = WebRequest.Create(url);
            HttpWebRequest httpRequest = webRequest as HttpWebRequest;
            if (httpRequest == null)
            {
                throw new ApplicationException(
                    string.Format("Invalid url string: {0}", url)
                    );
            }
            #endregion

            #region httpWebRequestĻϢ
            httpRequest.UserAgent = sUserAgent;
            httpRequest.ContentType = sContentType;
            httpRequest.Method = "POST";
            #endregion

            #region Ҫpost
            httpRequest.ContentLength = data.Length;
            Stream requestStream = httpRequest.GetRequestStream();
            requestStream.Write(data, 0, data.Length);
            requestStream.Close();
            #endregion

            #region post󵽷ȡϢ
            Stream responseStream;
            try
            {
                responseStream = httpRequest.GetResponse().GetResponseStream();
            }
            catch(Exception e)
            {
                // log error
                Console.WriteLine(
                    string.Format("POST쳣{0}", e.Message)
                    );
                throw e;
            }
            #endregion

            #region ȡϢ
            string stringResponse = string.Empty;
            using(StreamReader responseReader =
                new StreamReader(responseStream, Encoding.GetEncoding(sResponseEncoding)))
            {
                stringResponse = responseReader.ReadToEnd();
            }
            responseStream.Close();
            #endregion
            return stringResponse;
        }

        const string sUserAgent = 
            "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.2; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";
        const string sContentType = 
            "application/x-www-form-urlencoded";
        const string sRequestEncoding = "ascii";
        const string sResponseEncoding = "gb2312";
    }
}
